import pytest

from sorting.bubble import bubble_sort, bubble_sort_optimized
from sorting.insertion import insertion_sort
from sorting.merge import merge_sort

data_vectors: list[list[int]] = [
    [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20],
    [20, 19, 18, 17, 16, 15, 14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1],
    [3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5],
    [8, 83, 30, 56, 12, 42, 62, 61, 30, 20, 53, 42, 63, 25, 11, 49, 29, 22, 29, 91],
    [97, 72, 17, 10, 92, 16, 95, 88, 64, 60, 77, 99, 16, 44, 95, 73, 84, 86, 53, 16],
    [16, 76, 98, 47, 94, 24, 25, 11, 13, 62, 35, 73, 32, 48, 41, 70, 43, 13, 4, 27],
    [75, 18, 2, 3, 14, 43, 88, 35, 86, 54, 84, 97, 50, 77, 48, 43, 40, 97, 11, 32],
    [95, 4, 56, 92, 45, 4, 71, 2, 79, 5, 27, 97, 8, 33, 44, 9, 93, 35, 55, 37],
    [3, 72, 35, 91, 53, 28, 75, 18, 41, 30, 24, 65, 5, 6, 71, 50, 71, 15, 71, 19],
    [77, 43, 17, 18, 16, 89, 7, 72, 71, 7, 57, 9, 69, 17, 9, 47, 78, 20, 79, 21],
    [2, 80, 7, 25, 10, 72, 85, 48, 32, 13, 33, 87, 43, 35, 39, 81, 25, 90, 79, 32],
    [58, 92, 29, 28, 79, 62, 32, 8, 34, 13, 96, 65, 98, 9, 42, 23, 35, 26, 55, 78],
    [49, 73, 95, 70, 50, 93, 32, 100, 80, 44, 30, 64, 67, 36, 17, 15, 47, 55, 93, 46],
    [12, 48, 19, 74, 74, 10, 66, 68, 56, 59, 10, 57, 51, 87, 62, 93, 85, 87, 60, 40],
    [37, 80, 15, 12, 90, 69, 34, 22, 44, 6, 35, 94, 42, 53, 4, 14, 31, 65, 34, 48],
    [85, 35, 82, 6, 77, 62, 96, 25, 54, 30, 26, 48, 45, 80, 54, 37, 58, 85, 66, 61],
    [81, 67, 51, 13, 52, 27, 76, 15, 79, 19, 87, 76, 99, 89, 25, 14, 80, 91, 1, 58],
    [35, 89, 65, 37, 54, 42, 10, 31, 49, 15, 38, 98, 36, 39, 87, 62, 99, 7, 42, 41],
    [53, 74, 78, 36, 96, 23, 45, 30, 73, 15, 81, 75, 30, 34, 95, 8, 38, 12, 77, 6],
    [4, 9, 84, 84, 28, 61, 78, 15, 64, 10, 8, 7, 100, 12, 38, 41, 32, 32, 26, 6],
    [79, 69, 44, 44, 52, 29, 3, 57, 47, 37, 43, 100, 18, 20, 19, 8, 93, 30, 24, 52],
    [64, 78, 2, 40, 1, 31, 86, 71, 85, 68, 84, 49, 93, 69, 7, 21, 79, 80, 47, 65],
    [70, 22, 86, 34, 1, 44, 26, 83, 74, 28, 39, 43, 21, 32, 23, 80, 8, 50, 24, 30],
    [10, 19, 8, 54, 74, 53, 11, 94, 5, 34, 29, 69, 97, 11, 55, 71, 76, 16, 70, 68],
    [38, 80, 90, 68, 66, 10, 33, 20, 64, 61, 72, 24, 13, 65, 48, 72, 72, 80, 12, 44],
    [4, 59, 15, 58, 36, 40, 32, 69, 96, 3, 89, 93, 41, 81, 14, 43, 38, 32, 4, 77],
    [92, 69, 92, 71, 76, 65, 49, 28, 76, 50, 95, 15, 11, 78, 69, 88, 7, 91, 90, 16],
    [11, 3, 67, 74, 89, 73, 80, 55, 92, 18, 48, 81, 77, 84, 5, 65, 69, 82, 14, 92],
    [29, 13, 92, 86, 91, 11, 89, 69, 77, 8, 66, 4, 56, 35, 76, 27, 94, 16, 19, 95],
    [45, 19, 41, 99, 15, 19, 27, 81, 75, 18, 100, 41, 15, 58, 3, 55, 9, 35, 25, 32],
    [25, 14, 75, 77, 51, 6, 10, 22, 35, 4, 55, 51, 4, 35, 6, 52, 49, 26, 48, 80],
    [83, 72, 44, 51, 37, 41, 34, 40, 50, 97, 28, 45, 100, 17, 12, 22, 39, 21, 12, 17],
    [70, 12, 85, 25, 3, 91, 73, 35, 50, 43, 27, 11, 4, 91, 34, 31, 3, 52, 24, 1],
    [26, 50, 85, 93, 55, 11, 5, 29, 96, 99, 70, 75, 54, 39, 29, 76, 41, 74, 60, 13],
    [72, 25, 31, 47, 15, 3, 83, 38, 20, 18, 17, 81, 40, 9, 86, 86, 24, 68, 4, 86],
    [7, 15, 19, 13, 33, 39, 30, 61, 47, 22, 12, 36, 58, 20, 46, 90, 15, 52, 89, 11],
    [65, 2, 99, 76, 23, 32, 59, 1, 83, 60, 48, 78, 8, 16, 99, 61, 57, 65, 5, 44],
    [23, 59, 85, 67, 41, 37, 16, 98, 30, 87, 97, 61, 92, 41, 6, 16, 89, 41, 58, 24],
    [93, 55, 52, 47, 90, 27, 23, 18, 78, 46, 64, 46, 50, 71, 22, 17, 59, 86, 19, 43],
    [65, 69, 36, 72, 60, 44, 13, 81, 76, 51, 24, 44, 78, 38, 61, 28, 27, 62, 67, 13],
    [38, 99, 41, 86, 48, 43, 72, 36, 19, 7, 12, 18, 36, 53, 81, 41, 47, 40, 60, 54],
    [22, 27, 7, 53, 98, 9, 19, 34, 41, 82, 49, 74, 88, 74, 39, 68, 50, 65, 45, 38],
    [24, 41, 74, 12, 47, 50, 13, 68, 30, 58, 11, 37, 92, 74, 68, 40, 23, 71, 59, 52],
    [35, 34, 17, 25, 6, 10, 34, 24, 50, 35, 26, 33, 76, 67, 2, 51, 72, 43, 48, 79],
    [2, 56, 14, 15, 2, 93, 32, 13, 98, 99, 33, 17, 36, 86, 100, 91, 70, 24, 59, 33],
    [80, 57, 78, 65, 22, 93, 23, 26, 80, 85, 29, 67, 99, 29, 95, 67, 94, 74, 41, 21],
    [72, 44, 22, 71, 71, 22, 62, 35, 66, 20, 20, 39, 34, 38, 13, 18, 19, 72, 88, 87],
    [42, 21, 13, 75, 36, 61, 13, 81, 47, 48, 93, 28, 3, 89, 74, 27, 58, 87, 31, 32],
    [45, 77, 62, 93, 59, 53, 47, 96, 78, 78, 17, 56, 86, 18, 11, 27, 8, 39, 20, 20],
    [72, 92, 14, 47, 94, 77, 37, 15, 26, 21, 86, 46, 81, 80, 16, 54, 91, 11, 53, 11],
    [55, 32, 31, 60, 10, 87, 36, 22, 35, 37, 69, 92, 23, 44, 42, 80, 75, 83, 72, 99],
    [61, 94, 9, 43, 63, 53, 47, 79, 2, 33, 39, 25, 24, 52, 39, 22, 98, 5, 36, 52],
    [93, 41, 89, 30, 28, 45, 60, 50, 10, 77, 17, 53, 53, 9, 11, 100, 88, 84, 73, 12],
    [1, 45, 53, 76, 4, 18, 86, 86, 10, 99, 26, 14, 87, 72, 65, 97, 89, 100, 58, 24],
    [62, 36, 33, 3, 8, 1, 36, 92, 55, 73, 85, 33, 53, 2, 36, 99, 46, 68, 14, 37],
    [26, 50, 57, 90, 60, 64, 33, 97, 26, 35, 8, 34, 66, 75, 94, 29, 31, 31, 90, 68],
    [32, 60, 47, 47, 47, 12, 81, 71, 69, 32, 96, 84, 91, 89, 56, 22, 75, 76, 37, 85],
    [47, 91, 66, 28, 94, 98, 61, 76, 91, 34, 67, 78, 11, 9, 57, 54, 71, 50, 10, 63],
    [77, 92, 7, 1, 76, 4, 75, 59, 69, 72, 49, 47, 25, 50, 21, 27, 68, 15, 28, 91],
    [67, 41, 46, 17, 92, 81, 79, 9, 82, 66, 86, 55, 68, 64, 84, 46, 66, 26, 58, 98],
    [3, 71, 47, 17, 62, 31, 74, 85, 61, 34, 53, 54, 21, 34, 86, 11, 32, 41, 95, 17],
    [22, 26, 96, 84, 8, 81, 96, 51, 44, 3, 61, 34, 83, 28, 55, 92, 62, 67, 39, 20],
    [94, 55, 33, 2, 33, 9, 18, 57, 77, 53, 5, 63, 37, 32, 74, 83, 65, 63, 17, 59],
    [36, 59, 98, 16, 81, 17, 60, 78, 89, 61, 39, 84, 14, 58, 97, 25, 86, 64, 58, 59],
    [21, 53, 75, 87, 43, 14, 82, 100, 78, 24, 8, 100, 62, 92, 15, 100, 15, 95, 90, 39],
    [48, 73, 53, 21, 34, 98, 75, 97, 59, 60, 10, 32, 20, 86, 17, 92, 100, 27, 14, 49],
    [58, 94, 99, 74, 18, 21, 2, 57, 79, 88, 82, 31, 32, 100, 53, 37, 87, 43, 21, 51],
    [16, 96, 10, 8, 51, 50, 95, 36, 81, 9, 55, 76, 29, 31, 94, 23, 88, 5, 43, 70],
    [24, 92, 85, 17, 37, 36, 55, 10, 90, 82, 85, 45, 10, 10, 45, 49, 67, 43, 91, 52],
    [95, 88, 8, 92, 40, 46, 67, 35, 65, 7, 23, 23, 1, 84, 20, 73, 71, 59, 8, 6],
    [60, 95, 26, 46, 36, 5, 53, 96, 7, 50, 21, 88, 76, 55, 62, 26, 99, 84, 48, 14],
    [23, 73, 40, 72, 96, 26, 12, 38, 55, 3, 60, 44, 71, 18, 40, 93, 5, 13, 4, 79],
    [20, 94, 8, 12, 88, 8, 62, 80, 70, 55, 7, 62, 43, 66, 95, 29, 76, 11, 88, 78],
    [69, 3, 21, 34, 77, 90, 47, 99, 61, 77, 3, 64, 16, 26, 89, 60, 80, 13, 25, 51],
    [10, 62, 35, 93, 4, 5, 49, 58, 77, 78, 12, 16, 18, 41, 70, 30, 23, 20, 2, 79],
    [6, 82, 47, 28, 50, 19, 83, 91, 48, 96, 10, 1, 38, 70, 94, 22, 60, 6, 65, 24],
    [59, 79, 10, 98, 6, 38, 80, 58, 9, 78, 100, 35, 48, 20, 7, 55, 68, 23, 80, 21],
    [48, 54, 60, 66, 78, 57, 52, 3, 53, 69, 100, 67, 83, 37, 44, 44, 100, 21, 13, 3],
    [6, 73, 54, 19, 99, 57, 62, 78, 54, 59, 30, 43, 68, 13, 2, 72, 64, 29, 18, 70],
    [35, 98, 74, 71, 66, 32, 7, 64, 55, 51, 50, 13, 95, 57, 60, 46, 100, 93, 67, 3],
    [86, 97, 89, 90, 85, 100, 62, 29, 76, 34, 55, 15, 87, 88, 4, 61, 66, 22, 54, 10],
    [72, 63, 38, 75, 2, 43, 65, 21, 83, 62, 79, 59, 61, 69, 94, 61, 46, 86, 3, 23],
    [91, 73, 9, 74, 25, 37, 21, 57, 3, 6, 37, 87, 94, 6, 58, 46, 10, 100, 22, 29],
    [72, 48, 93, 15, 2, 96, 19, 89, 84, 1, 11, 20, 80, 2, 55, 9, 58, 75, 19, 69],
    [86, 46, 100, 76, 45, 28, 51, 65, 76, 53, 94, 67, 4, 15, 82, 5, 10, 52, 66, 35],
    [15, 13, 32, 63, 29, 39, 40, 64, 44, 65, 67, 56, 4, 66, 87, 25, 80, 46, 36, 76],
    [39, 78, 57, 81, 66, 79, 28, 10, 56, 52, 100, 42, 79, 95, 25, 32, 85, 17, 54, 55],
    [24, 38, 31, 99, 31, 88, 99, 61, 11, 88, 13, 52, 58, 92, 57, 88, 84, 44, 98, 78],
    [54, 95, 6, 62, 33, 100, 31, 37, 14, 83, 52, 36, 71, 71, 18, 22, 91, 50, 25, 41],
    [74, 62, 22, 66, 21, 12, 39, 31, 2, 29, 48, 73, 57, 81, 99, 41, 86, 31, 89, 73],
    [44, 93, 58, 37, 20, 16, 49, 50, 93, 24, 1, 8, 66, 7, 12, 76, 65, 69, 7, 92],
    [92, 38, 18, 6, 97, 20, 2, 56, 88, 59, 92, 38, 16, 53, 49, 42, 4, 52, 91, 98],
    [96, 27, 97, 67, 21, 19, 79, 18, 56, 14, 18, 22, 35, 98, 64, 20, 47, 42, 55, 84],
    [6, 14, 71, 28, 9, 52, 16, 83, 6, 87, 76, 26, 38, 34, 14, 90, 95, 5, 51, 29],
    [78, 75, 33, 11, 97, 30, 92, 36, 42, 36, 58, 82, 14, 53, 43, 48, 20, 8, 54, 7],
    [20, 32, 89, 51, 88, 13, 31, 18, 47, 97, 12, 89, 65, 32, 76, 20, 41, 52, 32, 84],
    [98, 39, 3, 77, 44, 58, 65, 12, 47, 26, 26, 89, 24, 33, 99, 22, 70, 26, 82, 13],
    [61, 71, 30, 1, 1, 60, 94, 66, 89, 50, 74, 92, 44, 92, 12, 77, 78, 29, 4, 33],
    [60, 15, 62, 83, 57, 12, 93, 35, 64, 22, 2, 24, 72, 40, 7, 10, 2, 21, 74, 9],
    [75, 7, 7, 99, 51, 41, 83, 59, 24, 8, 6, 26, 97, 53, 32, 64, 33, 18, 61, 91],
]


@pytest.mark.parametrize("test_data", data_vectors)
def test_bubble_sort(test_data: list[int]) -> None:
    sorted_data = bubble_sort(test_data)
    assert sorted_data == sorted(test_data)


@pytest.mark.parametrize("test_data", data_vectors)
def test_bubble_sort_optimized(test_data: list[int]) -> None:
    sorted_data = bubble_sort_optimized(test_data)
    assert sorted_data == sorted(test_data)


@pytest.mark.parametrize("test_data", data_vectors)
def test_insertion_sort(test_data: list[int]) -> None:
    sorted_data = insertion_sort(test_data)
    assert sorted_data == sorted(test_data)


@pytest.mark.parametrize("test_data", data_vectors)
def test_merge_sort(test_data: list[int]) -> None:
    sorted_data = merge_sort(test_data)
    assert sorted_data == sorted(test_data)
